#include "stdafx.h"
#include "NxPhysics.h"
#include "Ogre.h"
#include "Skate.h"
#include "AI.h"

using namespace Ogre;

#ifndef H_AISkate
#define H_AISkate

class AISkate : public FrameListener {

	Skate* skate;
	NxActor* actor;

	AI* ai;
	std::vector<Skate*> targets;
	Skate* target;
			
public:
	AISkate(SceneManager* sceneManager, PhysicsHandler* physxHandler, Vector3 pos, Vector3 dir, String name) {
		skate = new Skate(sceneManager, pos, dir, name, 50);
		actor = physxHandler->addSkate(skate->getSceneNode(), skate->getSmoker()->getSceneNode());
		skate->setActor(actor);
		ai = new AI("strategy1.ai", skate, sceneManager, physxHandler);
		target = NULL;
	}

	void addTarget(Skate* target) {
		targets.push_back(target);
	}

	Skate* getSkate() {
		return skate;
	}

	bool update(float t, float dt) {
		
		if(skate->isAlive()) {
			if(target == NULL || !target->isAlive()) {
				std::vector<Skate*> atargets;
				for(unsigned int i=0;i<targets.size();i++) {
					Skate* oskate = targets[i];
					if(oskate->isAlive()) {
						atargets.push_back(oskate);
					}
				}
				if(atargets.size() > 0) {
					int t = rand() % atargets.size();
					target = atargets[t];
				}
			}
			/*double minDist = 999999;
			Skate* target = NULL;
			for(unsigned int i=0;i<targets.size();i++) {
				Skate* oskate = targets[i];
				if(oskate->isAlive()) {
					double dist = (oskate->getPosition() - skate->getPosition()).length();
					if(dist < minDist) {
						minDist = dist;
						target = oskate;
					}
				}
			}*/

			if(target != NULL) {
				double dist = (target->getPosition() - skate->getPosition()).length();
				Vector3 distVector = skate->getPosition() - target->getPosition();
				Vector3 direction = skate->getDirection();
				double angle = distVector.angleBetween(direction).valueDegrees();
				distVector.normalise();
				direction.normalise();
				double r = direction.crossProduct(distVector).y;
			
				if(r > 0) {
					angle = 180-angle;
				} else {
					angle = angle-180;
				}
				//std::cout<<skate->getSceneNode()->getName()<<" "<<target->getSceneNode()->getName()<<" "<<minDist<<" r:"<<r<<" a:"<<angle<<"\n";
				ai->fire(dist, angle);		
				
	
			}

			skate->update(t, dt);
		}
		return true;
	}

};

#endif