#pragma once
#include "Ogre.h"
#include "NxPhysics.h"
#include "PhysxHandler.h"

class Level
{
	void loadLevel(const char* fileName, SceneManager* sm, PhysicsHandler* physxHandler);
	void createWall(SceneManager* sm, double px, double pz, double sx, double sz, const char* mat, int id);
	void createHill(SceneManager* sm, PhysicsHandler* ph, double s, double angle1, double angle2, double px, double pz, int id);
	void createFire(SceneManager* sm, double px, double pz, int id);
	void createLight(SceneManager* sm);
	void createGround(SceneManager* sm);
	void createHouse(SceneManager* sm, PhysicsHandler* ph, double px, double pz, int id);
	ManualObject* createCubeMesh(Ogre::String name, Ogre::String matName);

public:
	Level(Ogre::SceneManager* sm, PhysicsHandler* physxHandler);
	~Level(void);
};
