#include "Ogre.h"
using namespace Ogre;

#ifndef H_PSFS
#define H_PSFS

class PSysFromScript
{

	ParticleSystem* psys;
	SceneNode* sysNode;

public:
	
	PSysFromScript(Vector3 position, SceneManager* sm, String scriptname)
	{
		static int id = 0;
		sysNode = sm->getRootSceneNode()->createChildSceneNode("psysNode"+StringConverter::toString(id));
		psys = sm->createParticleSystem("psys"+StringConverter::toString(id), scriptname);
		sysNode->attachObject(psys);
		sysNode->setPosition(position);
		id++;
	}

	void setEmissionRate(int er) {
		ParticleEmitter* pe = psys->getEmitter(0);
		pe->setEmissionRate(er);
	}

	void updateER(int d) {
		ParticleEmitter* pe = psys->getEmitter(0);
		int er = pe->getEmissionRate();
		if((d < 0 && er > 0) || (d > 0)) {
			pe->setEmissionRate(er+d);
		}
	}

	ParticleSystem* getPS() {
		return psys;
	}

	SceneNode* getSceneNode() {
		return sysNode;
	}
};

#endif