#include "StdAfx.h"
#include "PlayerController.h"


PlayerController::PlayerController(Skate* skate, SceneManager* sm, PhysicsHandler* ph)
{
	this->skate = skate;
	this->ph = ph;
	this->sm = sm;
}

PlayerController::~PlayerController(void)
{
}

void PlayerController::update(float t, float dt, OIS::Keyboard* keyboard, OIS::Mouse* mouse)
{
	if (mTimeUntilNextToggle >= 0)
		mTimeUntilNextToggle -= dt;
		
	const OIS::MouseState &ms = mouse->getMouseState();

	if(skate->isAlive()) {
		if( keyboard->isKeyDown(OIS::KC_UP)) {
			skate->move(20 * dt);
		}
		if( keyboard->isKeyDown(OIS::KC_DOWN))
				skate->move(20 * -dt);
		if( keyboard->isKeyDown(OIS::KC_RIGHT)) {
			skate->turn(-1);
		}
		if( keyboard->isKeyDown(OIS::KC_LEFT)) {
			skate->turn(1);
		}
		if( keyboard->isKeyDown(OIS::KC_SPACE)) {
			SceneNode* ballNode = sm->getRootSceneNode()->createChildSceneNode();
			if(skate->shoot(ballNode)) {
				NxQuat dir = skate->getActor()->getGlobalOrientationQuat();
				ph->addShot(ballNode, dir);
			}
		}
	}
}
