#pragma once
#include "Ogre.h"
#include "NxPhysics.h"
#include "Particles.h"

using namespace Ogre;


#ifndef H_C_SKATE
#define H_C_SKATE

class Skate
{
protected:

	Entity* entity;
	SceneNode* node;
	SceneManager* sceneManager;


	NxActor* actor;

	double dv;
	double V_MAX;
	double ang;
	double ANG_MAX;
	double shoot_time;
	double SHOOT_TIME_MAX;
	int id;
	double life;
	Ogre::String name;
	PSysFromScript* smoker;

public:
	Skate(Ogre::SceneManager* sm, Vector3 pos, Vector3 dir, Ogre::String name, double _V_MAX);
	~Skate(void);
	void update(float t, float dt);
	Ogre::Vector3 getDirection(){return node->getOrientation() * Ogre::Vector3::UNIT_Z;}
	Ogre::Vector3 getPosition(){return node->getPosition();}

	void move(float amount);
	void turn(float amount);
	bool shoot(SceneNode* ballNode);

	bool isAlive();

	Ogre::SceneNode* getSceneNode();

	void setActor(NxActor* _actor) {
		actor = _actor;
	}

	NxActor* getActor() {
		return actor;
	}

	PSysFromScript* getSmoker() {
		return smoker;
	}

	void damage(double amount) {
		life -= amount;
		smoker->updateER(amount);
	}

};


#endif