#include "StdAfx.h"
#include "ThirdPersonCamera.h"

using namespace Ogre;

ThirdPersonCamera::ThirdPersonCamera(void)
{
	camera = 0;
	skate = 0;
	angle1 = 0;
	angle2 = 0;
	rot = Quaternion::IDENTITY;
	camHeight = 0.5f;
	camDist = 8;
	targetHeight = 2;
	motionBlend = 8.0f;
	
}

ThirdPersonCamera::~ThirdPersonCamera(void)
{

}

void ThirdPersonCamera::reset()
{
	if(camera == 0 || skate == 0)
		return;

	Vector3 dir = skate->getDirection();
	dir.y = 0;
	dir.normalise();
	dir.y = -camHeight;
	

	camera->setPosition(skate->getPosition() - dir * camDist);
	camera->lookAt(skate->getPosition() + Vector3(0,targetHeight,0));
}

void ThirdPersonCamera::update(float t, float dt)
{
	Vector3 currentPos = camera->getPosition();

	Vector3 dir = skate->getDirection();
	//dir.z = -dir.z;
	dir.y = 0;
	dir.normalise();
	dir.y = -camHeight;

	//double ar = skate->getSceneNode()->getOrientation().getYaw().valueRadians();
	Vector3 newPos = skate->getPosition() - dir * camDist;
	//newPos.x = newPos.x + cos(ar);
	//newPos.z = newPos.z - sin(ar);
	//newPos.x = newPos.x;
	camera->setPosition(motionBlend * dt * newPos + (1.0f - motionBlend * dt) * currentPos);
	camera->lookAt(skate->getPosition() + Vector3(0,targetHeight,0));

}
