#pragma once
#include "Ogre.h"
#include "Skate.h"

class ThirdPersonCamera
{
public:

	ThirdPersonCamera();
	~ThirdPersonCamera(void);
	void setCharacter(Skate* c)
	{ skate = c; reset();}
	void setCamera(Ogre::Camera* camera)
	{ this->camera = camera; reset();}
	void update(float t, float dt);
protected:
	Ogre::Camera* camera;
	Skate* skate;	
	void reset();
	Ogre::Radian angle1;
	Ogre::Radian angle2;
	Ogre::Quaternion rot;
	float camHeight;
	float camDist;
	float targetHeight;
	float motionBlend;
};
