#include "Ogre.h"

using namespace Ogre;

class BillBoardCloudTree
{

	SceneNode* treeNode;

public:
	BillBoardCloudTree(Vector3 position, SceneManager* sm)
	{
		static int id = 0;
		
		treeNode = sm->getRootSceneNode()->createChildSceneNode();
		treeNode->setPosition(position);
		treeNode->scale(1, 1.5, 1);
		treeNode->rotate(Vector3::UNIT_Y, Radian(Math::RangeRandom(0,Math::PI * 2)));
		Entity* trunk = sm->createEntity("treetrunk"+StringConverter::toString(id), "tree.mesh");
		treeNode->attachObject(trunk);
			
		
		BillboardSet* billboardCloud = sm->createBillboardSet("treebbcloud"+StringConverter::toString(id));
		treeNode->attachObject(billboardCloud);
		billboardCloud->setBillboardType(BBT_PERPENDICULAR_SELF);
		billboardCloud->setMaterialName("TreeLeaves");
		billboardCloud->setSortingEnabled(true);
	
		for(int i = 0; i < 12; i++)
		{
			float h = Math::RangeRandom(2.5,3.5);
			Vector3 pos(0,h,0);
			Vector3 dir(Math::RangeRandom(-1.0f,1.0f),Math::RangeRandom(0.0f,0.2f),Math::RangeRandom(-1.0f,1.0f));
			dir.normalise();
			Billboard* bb = billboardCloud->createBillboard(pos);
			bb->setDimensions(8.0f, 8.0f - h);
			bb->mDirection = dir;			
		}

		id++;

	}

	SceneNode* getSceneNode() {
		return treeNode;
	}
};

